package com.gxwebsoft.oa.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gxwebsoft.oa.mapper.OaTaskMapper;
import com.gxwebsoft.oa.service.OaTaskService;
import com.gxwebsoft.oa.entity.OaTask;
import com.gxwebsoft.oa.param.OaTaskParam;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.PageResult;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 任务记录表Service实现
 *
 * @author 科技小王子
 * @since 2024-09-10 20:57:42
 */
@Service
public class OaTaskServiceImpl extends ServiceImpl<OaTaskMapper, OaTask> implements OaTaskService {

    @Override
    public PageResult<OaTask> pageRel(OaTaskParam param) {
        PageParam<OaTask, OaTaskParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        List<OaTask> list = baseMapper.selectPageRel(page, param);
        return new PageResult<>(list, page.getTotal());
    }

    @Override
    public List<OaTask> listRel(OaTaskParam param) {
        List<OaTask> list = baseMapper.selectListRel(param);
        // 排序
        PageParam<OaTask, OaTaskParam> page = new PageParam<>();
        page.setDefaultOrder("create_time desc");
        return page.sortRecords(list);
    }

    @Override
    public OaTask getByIdRel(Integer taskId) {
        OaTaskParam param = new OaTaskParam();
        param.setTaskId(taskId);
        return param.getOne(baseMapper.selectListRel(param));
    }

}
